Codecov always fails with 404 Not Found - Build has already finished, uploads rejected
2021-02-22 08:36 - cdywan

Status: Resolved Start date: 2021-02-22
Priority: Normal Due date: 2021-03-09
Assignee: cdywan % Done: 0%
Category: Concrete Bugs Estimated time: 0.00 hour
Target version: Ready

Difficulty:

Description

Observation

Several open PRs currently seem to fail with codecov issues like these ones in the write step:

Use of uninitialized value S$report in ucfirst at /usr/bin/cover line 233.

Reading database from /home/squamata/project/cover_db_api

Merging database from cover_db_fullstack

Devel::Cover: Warning: can't open /home/squamata/os—-autoinst/autotest.pm for MD5 digest: No such f
ile or directory

Devel::Cover: Warning: can't open /home/squamata/os—-autoinst/OpenQA/Isotovideo/Interface.pm for MD
5 digest: No such file or directory

[oool

Devel::Cover: Warning: can't open /home/squamata/os—autoinst/signalblocker.pm for MD5 digest: No s
uch file or directory

<80> does not match <35> - using later value at /usr/lib/perl5/vendor_perl/5.26.1/x86_64-1linux-thr
ead-multi/Devel/Cover/DB.pm line 325.

<80> does not match <39> - using later value at /usr/lib/perl5/vendor_perl/5.26.1/x86_64-1linux-thr
ead-multi/Devel/Cover/DB.pm line 325.

[oool

<80> does not match <121> - using later value at /usr/lib/perl5/vendor_perl/5.26.1/x86_64-1linux-th
read-multi/Devel/Cover/DB.pm line 325.

<80> does not match <122> - using later value at /usr/lib/perl5/vendor_perl/5.26.1/x86_64-1inux-th
read-multi/Devel/Cover/DB.pm line 325.

Writing database to cover_db

CircleCI received exit code 0

and these in the select _re step:

Reading database from /home/squamata/project/cover_db

Devel::Cover: Warning: can't locate structure for statement in /home/squamata/os—autoinst/OpenQA/B
enchmark/Stopwatch.pm

[...]

1ib/OpenQA/App.pm 100.0 100.0

[oool]

404 Not Found {"detail":"Build has already finished, uploads rejected."}

Acceptance criteria

e ACH:

Suggestion

e The list of files reported seems to be unsorted but otherwise the same.

¢ os-autoinst/openQA#3742 was the last successful codecov run

e The errors are the same *except for the last message 404 Not Found {"detail":"Build has already finished, uploads rejected."}
instead of 200 OK Coverage reports upload successfully

History
https://github.com/os-autoinst/openQA/pull/3742

#1 - 2021-02-22 08:37 - okurz
- Category set to Concrete Bugs
- Priority changed from Normal to Urgent

- Target version set to Ready

#2 - 2021-02-22 10:33 - kraih

It is not possible to report the problem upstream, the issue tracker the module Devel::Cover::Report::Codecov links to is deactivated.
https://github.com/codecov/codecov-perl/issues

#3 - 2021-02-22 17:22 - tinita

I think the warning can't locate structure for statement is unrelated, also successful runs have warnings like that.
We should probably try to switch to codecov-bash.

#4 - 2021-02-22 17:43 - cdywan

- Description updated

- Status changed from New to In Progress

- Assignee set to cdywan
#5 - 2021-02-22 17:48 - cdywan
tinita wrote:
| think the warning can't locate structure for statement is unrelated, also successful runs have warnings like that.
Yes, sadly. | was investigating the warnings, then thought to trace the last successful run to check the expected result and confirmed that all of these
were there before. Except for the 404 in the end.
Incidentally HTML has been written despite not being mentioned. Nothing seems to be missing from the artifacts.
So my PR is probably not helping at all (or just fixes one of the unrelated errors).

#6 - 2021-02-22 17:54 - cdywan

- Description updated

#7 - 2021-02-22 18:12 - cdywan

- Subject changed from Devel::Cover: Warning: can't locate structure for statement in /home/squamata/os-autoinst/OpenQA/Benchmark/Stopwatch.pm
to Codecov always fails with 404 Not Found - Build has already finished, uploads rejected

#8 - 2021-02-22 18:28 - cdywan

tinita wrote:

We should probably try to switch to codecov-bash.

Do you think codecov-bash is better maintained? [l I didn't spot any recent fixes there that could help us.

But it seems easy enough to try out. | actually like the friendly CLI output and it seems like it would be easier to debug than what we have now.

#9 - 2021-02-22 20:28 - cdywan

cdywan wrote:
tinita wrote:

We should probably try to switch to codecov-bash.

Do you think codecov-bash is better maintained? [I[] | didn't spot any recent fixes there that could help us.

Well, they apparently have the same problems.

#10 - 2021-02-23 04:06 - openqga_review
https://metacpan.org/pod/Devel::Cover::Report::Codecov
https://github.com/codecov/codecov-perl/issues
https://github.com/os-autoinst/openQA/pull/3749
https://github.com/codecov/codecov-bash
https://github.com/os-autoinst/openQA/pull/3751
https://github.com/codecov/codecov-bash
https://github.com/codecov/codecov-bash/issues/411

- Due date set to 2021-03-09

Setting due date based on mean cycle time of SUSE QE Tools

#11 - 2021-02-24 08:55 - cdywan

e Despite my earlier findings codecov-bash seems able to upload data successfully.
¢ Devel::Cover::Report::Codecovbash is not currently packaged so | used it via CPAN in my PR.

#12 - 2021-02-24 11:31 - okurz
Open points we can cover after the inital fix is merged:
e Use properly packaged dependencies

¢ Remove the explicit dependency for perl-JSON-MaybeXS
¢ Consider adding back coverage-html: coverage in Makefile to ensure coverage analysis is done when the report generation is triggered

#13 - 2021-02-24 13:26 - cdywan
okurz wrote:
Open points we can cover after the inital fix is merged:
e Use properly packaged dependencies
¢ Remove the explicit dependency for perl-JSON-MaybeXS
Looking into that atm, with some help from tinita
e Consider adding back coverage-html: coverage in Makefile to ensure coverage analysis is done when the report generation is triggered

As far as | can tell that target was unused. At least it didn't work for me locally. | would suggest that we prefer to maintain targets that we use in Cl
where possible.

#14 - 2021-02-24 13:29 - okurz

| would suggest that we prefer to maintain targets that we use in Cl where possible.

As far as we can do that | consider this a good idea. But a local developer likely prefers an HTML report over codecov format for readability :)
#15 - 2021-02-24 13:30 - okurz

And now the problem is when | call manually | get:

$ make coverage-—html

cover -select_re '~ (lib|script|t)/' -report html_minimal

Can't open database /home/okurz/local/os-autoinst/openQA/cover_db
make: *** [Makefile:212: coverage-html] Error 2

#16 - 2021-02-24 15:43 - cdywan
cdywan wrote:
okurz wrote:
Open points we can cover after the inital fix is merged:
e Use properly packaged dependencies
e Remove the explicit dependency for perl-JSON-MaybeXS

Looking into that atm, with some help from tinita

See SR#874893

#17 - 2021-02-24 15:44 - okurz

- Priority changed from Urgent to Normal
progress.opensuse.org/users/33482
progress.opensuse.org/users/33482
https://build.opensuse.org/request/show/874893

great. Definitely you already tackled the "urgency" of the problem.

#18 - 2021-02-24 18:16 - cdywan
- Description updated
okurz wrote:
And now the problem is when | call manually | get:
$ make coverage-—html
cover -select_re '~ (lib|script|t)/' -report html_minimal

Can't open database /home/okurz/local/os-autoinst/openQA/cover_db
make: *** [Makefile:212: coverage—-html] Error 2

https://github.com/o0s-autoinst/openQA/pull/3753

#19 - 2021-03-03 14:38 - cdywan

cdywan wrote:

See SR#874893

The SR got accepted, so we can probably swap out cpanm for rpm here: https:/github.com/os-autoinst/openQA/pull/3762

#20 - 2021-03-04 13:10 - cdywan

- Status changed from In Progress to Feedback

Follow-up PR was merged and seems to be working fine so far...

#21 - 2021-03-09 09:44 - cdywan

- Status changed from Feedback to Resolved

No objections/ problems reported at this point
